package org.dromara.work.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.dromara.system.mapper.SysUserMapper;
import org.springframework.stereotype.Service;
import org.dromara.work.domain.bo.TpFollowBo;
import org.dromara.work.domain.vo.TpFollowVo;
import org.dromara.work.domain.TpFollow;
import org.dromara.work.mapper.TpFollowMapper;
import org.dromara.work.service.ITpFollowService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 关注Service业务层处理
 *
 * @author Maosw
 * @date 2025-07-23
 */
@RequiredArgsConstructor
@Service
public class TpFollowServiceImpl implements ITpFollowService {

    private final TpFollowMapper baseMapper;

    private final SysUserMapper sysUserMapper;

    /**
     * 查询关注
     *
     * @param id 主键
     * @return 关注
     */
    @Override
    public TpFollowVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询关注列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 关注分页列表
     */
    @Override
    public TableDataInfo<TpFollowVo> queryPageList(TpFollowBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<TpFollow> lqw = buildQueryWrapper(bo);
        Page<TpFollowVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        //获取用户对象
        result.getRecords().forEach(
            r -> r.setToUser(sysUserMapper.selectById(r.getToUserId()))
        );
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的关注列表
     *
     * @param bo 查询条件
     * @return 关注列表
     */
    @Override
    public List<TpFollowVo> queryList(TpFollowBo bo) {
        LambdaQueryWrapper<TpFollow> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<TpFollow> buildQueryWrapper(TpFollowBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<TpFollow> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(TpFollow::getId);
        lqw.eq(bo.getUserId() != null, TpFollow::getUserId, bo.getUserId());
        lqw.eq(bo.getToUserId() != null, TpFollow::getToUserId, bo.getToUserId());
        return lqw;
    }

    /**
     * 新增关注
     *
     * @param bo 关注
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(TpFollowBo bo) {
        TpFollow add = MapstructUtils.convert(bo, TpFollow.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改关注
     *
     * @param bo 关注
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(TpFollowBo bo) {
        TpFollow update = MapstructUtils.convert(bo, TpFollow.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(TpFollow entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除关注信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }

    /**
     * 查询关注
     *
     * @param bo 查询条件
     * @return 关注
     */
    @Override
    public TpFollowVo queryByTpFollow(TpFollowBo bo) {
        return baseMapper.selectVoOne(new LambdaQueryWrapper<TpFollow>().eq(TpFollow::getUserId, bo.getUserId()).eq(TpFollow::getToUserId, bo.getToUserId()));
    }
}
